# Grugs around the fire

## You probably don't need to care

Datastar started as an attempt to move HTMX to Typescript (for internal development). Both HTMX and Datastar are just a single CDN include for end users. Unless you want to get into contributing of this may seem like bike shedding around tools and language. I personally think it matters because it's been pretty clear from internal use the end user can have smaller, faster and easier tools while the framework developer can have a more robust and maintainable codebase.

## Wise words

As [old time grug](https://grugbrain.dev/) explain well,

> apex predator of grug is complexity
> complexity bad
>
> say again:
> complexity very bad
>
> you say now:
> complexity very, very bad
>
> given choice between complexity or one on one against t-rex, grug take t-rex: at least grug see t-rex

Some think not big brain and no like complexity but complexity spirit demon seems different for different smol brains. This grug think set up of things like build steps and compilers avoid long-term pacts with demons in own brain.

## Spirit demon takes many forms

[King grug](https://bigsky.software/cv/) have many [stories](https://htmx.org/essays/) about simplifying so that grug work not scary. However the way that King grug [make code](https://github.com/bigskysoftware/htmx/blob/master/src/htmx.js) make other grug feel less smart that smol brain; maybe not grug at all but lizard in grug body. No care if big file but do care many concept all mashed together in one big complexity rock. Then most time need other complexity rock ([hyperscript](https://hyperscript.org/)/[Alpine.js](https://alpinejs.dev/)) to react to first complexity rock make grug sad. Rocks different size but much overlap. Understand why things be that way but better club might be available. Maybe just rock but feels like apex predator disguised as rock.

## Some grug like stick club cause simpler make, some grug like spike club cause simpler to take down T-Rex

Some old clubs still work good but that don't mean ignoring clubs that have spike in them. If build step take less than grug blink then grug happy, no slow down, find problem smol brain miss. Seems less complex to keep in head. Most complexity in this project lives in single file less that [240 lines](https://github.com/starfederation/datastar/blob/main/library/src/engine/engine.ts#L245-L472). Even lizard brain can keep that in head.

This smol brain make new project that makes each part own plug-in, own file, but that not necessary, but make tree shake easier. Everything plug-in make simpler. Use HTML without monkeys or eval. Grug learn from other grug but think found better club. May not be simpler at start of project but much simpler and less think over whole hunt. Grug like to think about hunt, not club or who messed with it.

## It's there

Ask King grug [has said](https://discord.com/channels/725789699527933952/974086000307499028/1149771130798878790)

> javascript has one amazing, overriding, unbelievable feature that every other programming language in the world lacks: it's there

This is true and make it only target for doing things that are smol (WASM maybe someday). Treating like only club seem silly and shift big brain steps like minification, build targets, type constraints, etc to a smol brain where make sad. Sad grug not productive grug.

## Around the fire

In the end both ways have good vibes but hope hyper-cave have room for different grugs at the same fire. If you no want spike in club cuz too much work to do, no problem, we provide club in [many forms](https://vitejs.dev/config/build-options.html#build-target) so should make happy. Even has instructions on [how to use](https://www.typescriptlang.org/docs/handbook/declaration-files/templates/module-d-ts.html) and where club [comes from](https://firefox-source-docs.mozilla.org/devtools-user/debugger/how_to/use_a_source_map/index.html) if grug want to use with own tablet.

## Plea for big brain smarts

If there are big brain typescript shaman, us smol brains could use your help making the types even better. Have ideas around partials but smol brain sad with lack of deep ritual magic. If want make better world for all please hit smol brain overhead on [Discord](https://discord.com/channels/1035247242887561326/1149367785374359613)
