# SDKs

Datastar provides backend SDKs that simplify the process of generating [SSE events](/reference/sse_events) specific to Datastar. Alternatively, use your backend as is to [send SSE events](https://developer.mozilla.org/en-US/docs/Web/API/Server-sent_events/Using_server-sent_events#sending_events_from_the_server).

If you'd like to contribute an SDK, please follow the [Contribution Guidelines](https://github.com/starfederation/datastar/blob/main/CONTRIBUTING.md#sdks).

## Clojure

Clojure [SDK](https://github.com/starfederation/datastar/tree/main/sdk/clojure) and [examples](https://github.com/starfederation/datastar/tree/main/examples/clojure).  
_Author: [Jeremy Schoffen](https://github.com/JeremS)_

## C# (.NET)

C# (.NET) [SDK](https://github.com/starfederation/datastar/tree/main/sdk/dotnet) and [examples](https://github.com/starfederation/datastar/tree/main/examples/dotnet).  
_Author: [Greg H](https://github.com/SpiralOSS)_

## Go

Go [SDK](https://github.com/starfederation/datastar/tree/main/sdk/go) and [examples](https://github.com/starfederation/datastar/tree/main/examples/go).  
_Author: [Delaney Gillilan](https://github.com/delaneyj)_

Other examples:  
[1 App 5 Stacks ported to Go+Templ+Datastar](https://github.com/delaneyj/1a5s-datastar)

## Haskell

Haskell [SDK](https://github.com/starfederation/datastar/tree/main/sdk/haskell) and [examples](https://github.com/starfederation/datastar/tree/main/examples/haskell).  
 _Author: [Henry Laxen](https://github.com/henrylaxen)_
 
## Java

Java [SDK](https://github.com/starfederation/datastar/blob/develop/sdk/java).  
_Author: [Peter Humulock](https://github.com/rphumulock)_

## PHP

PHP [SDK](https://github.com/starfederation/datastar-php) and [examples](https://github.com/starfederation/datastar/tree/main/examples/php).    
_Author: [Ben Croker](https://github.com/bencroker) ([PutYourLightsOn](https://putyourlightson.com/))_

### Laravel

[Laravel package](https://github.com/putyourlightson/laravel-datastar)  

### Craft CMS

[Craft CMS plugin](https://putyourlightson.com/plugins/datastar)  

Other examples:  
[Craft Datastar Pokemon demo](https://github.com/khalwat/craft-datastar-pokemon-demo)  

## Python

Python [SDK](https://github.com/starfederation/datastar/tree/main/sdk/python), [examples](https://github.com/starfederation/datastar/tree/main/examples/python), and [PyPI package](https://pypi.org/project/datastar-py/), including support for Sanic, Django, Quart and FastAPI.  
_Author: [Felix Ingram](https://github.com/lllama)_

## Rust

Rust [SDK](https://github.com/starfederation/datastar/tree/main/sdk/rust) and [examples](https://github.com/starfederation/datastar/tree/main/examples/rust).  
 _Author: [Johnathan Stevers](https://github.com/jmstevers)_

## Ruby

Ruby [SDK](https://github.com/starfederation/datastar/tree/main/sdk/ruby) and [examples](https://github.com/starfederation/datastar/tree/main/examples/ruby).  
 _Author: [Ismael Celis](https://github.com/ismasan)_

## TypeScript

TypeScript [SDK](https://github.com/starfederation/datastar/tree/main/sdk/typescript) and [examples](https://github.com/starfederation/datastar/tree/main/sdk/typescript/examples), including support for NodeJS and Web standard runtimes (Deno, Bun, etc.).  
_Author: [Patrick Marchand](https://github.com/Superpat)_

## Zig

Zig [SDK](https://github.com/starfederation/datastar/tree/main/sdk/zig) and [examples](https://github.com/starfederation/datastar/tree/main/examples/zig).  
 _Author: [Johnathan Stevers](https://github.com/jmstevers)_

